var dtSettings = {

  /* Assign preferences service to variable*/
  dtPrefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null),
  winMediator: Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator),
  showItems: new Array(),

  // Assign used element id's and used preferences to constants
  Consts: {
    IDS: {
      TEXT: ['back-history-textbox', 'forward-history-textbox'],
      CHECKBOX: ['select-tab-checkbox', 'tablib-enabled-checkbox', 'back-history-checkbox', 'forward-history-checkbox',
        'scroll-position-checkbox', 'zoom-factor-checkbox', 'duptab-merge-windowclose',
        'duptab-merge-windowclose-showmessage', 'duptab-context-showontab', 'duptab-context-showonpage',
        'duptab-tab-context-showinsubmenu', 'duptab-content-context-showinsubmenu', 'duplicatetab-middleclick-link-checkbox',
        'duplicatetab-middleclick-backfw-checkbox', 'duptab-merge-merge-popups', 'duptab-merge-placepopupnextto-opener'],
      RADIO: ['duptab-merge-radiogroup'],
      SHOWITEMS: ['duptab-tab-context-nosubmenu-showtab', 'duptab-tab-context-nosubmenu-showwindow',
        'duptab-tab-context-nosubmenu-showmerge', 'duptab-content-context-nosubmenu-showtab',
        'duptab-content-context-nosubmenu-showwindow', 'duptab-content-context-nosubmenu-showmerge'],
      COLLAPSEBOXES: ['duptab-tab-context-submenu-vbox', 'duptab-content-context-submenu-vbox']
    },
    PREFS: {
      TEXT: ['duplicatetab.back-history.length', 'duplicatetab.forward-history.length'],
      BOOL: ['duplicatetab.newtab.focus', 'duplicatetab.tablib.enabled', 'duplicatetab.back-history.enabled', 'duplicatetab.forward-history.enabled', 'duplicatetab.zoomfactor.enabled',
        'duplicatetab.scrollposition.enabled', 'duplicatetab.merge.closeOnSelect', 'duplicatetab.merge.promptOnClose',
        'duplicatetab.showContextMenu.onTab', 'duplicatetab.showContextMenu.onContentArea', 'duplicatetab.showContextMenu.inSubMenu',
        'duplicatetab.showContextMenu.inContentSubMenu', 'duplicatetab.link.middleclick.open_in_duplicate_tab',
        'duplicatetab.bfhistory.middleclick.open_in_duplicate_tab', 'duplicatetab.merge.mergePopups',
        'duplicatetab.merge.placePopupNextToOpener'],
      RADIO: ['duplicatetab.merge.mergeAllWindows'],
      SHOWITEMS: ['duplicatetab.showContextMenu.items']
    }
  },

  /* Set values of checkboxes and textboxes to current preferences for extension */
  onLoad: function()
  {
    var i, j;
    document.getElementById(dtSettings.Consts.IDS.CHECKBOX[6]).addEventListener("CheckboxStateChange", dtSettings.setDisabledFirst, false);
    document.getElementById(dtSettings.Consts.IDS.CHECKBOX[8]).addEventListener("CheckboxStateChange", dtSettings.collapseContent, false);
    document.getElementById(dtSettings.Consts.IDS.CHECKBOX[9]).addEventListener("CheckboxStateChange", dtSettings.collapseContent, false);
    document.getElementById(dtSettings.Consts.IDS.CHECKBOX[10]).addEventListener("CheckboxStateChange", dtSettings.disableMenuItems, false);
    document.getElementById(dtSettings.Consts.IDS.CHECKBOX[11]).addEventListener("CheckboxStateChange", dtSettings.disableMenuItems, false);
    document.getElementById(dtSettings.Consts.IDS.CHECKBOX[14]).addEventListener("CheckboxStateChange", dtSettings.setDisabledSecond, false);
    for (i=0;i<dtSettings.Consts.PREFS.BOOL.length;i++) {
      document.getElementById(dtSettings.Consts.IDS.CHECKBOX[i]).checked = dtSettings.dtPrefs.getBoolPref(dtSettings.Consts.PREFS.BOOL[i]);
    }
    for (i=0;i<dtSettings.Consts.IDS.TEXT.length;i++) {
      document.getElementById(dtSettings.Consts.IDS.TEXT[i]).value = dtSettings.dtPrefs.getIntPref(dtSettings.Consts.PREFS.TEXT[i]);
    }
    var menuItemsPref = dtSettings.dtPrefs.getCharPref(dtSettings.Consts.PREFS.SHOWITEMS[0]);
    for (i=0,j=3;i<3;i++,j++) {
      document.getElementById(dtSettings.Consts.IDS.SHOWITEMS[i]).checked = Boolean(parseInt(menuItemsPref.charAt(i))%2);
      document.getElementById(dtSettings.Consts.IDS.SHOWITEMS[j]).checked = Boolean(parseInt(menuItemsPref.charAt(i))>1);
    }
    document.getElementById(dtSettings.Consts.IDS.RADIO[0]).selectedIndex = (dtSettings.dtPrefs.getBoolPref(dtSettings.Consts.PREFS.RADIO[0]))?0:1;
    dtSettings.checkForTablib();
  },

  // check whether the choice should be present to open a new tab next to the original using tablib (http://mozilla.dorando.at)
  checkForTablib: function()
  {
    var tablibCheckBox1 = document.getElementById(dtSettings.Consts.IDS.CHECKBOX[1]);
    var tablibCheckBox2 = document.getElementById(dtSettings.Consts.IDS.CHECKBOX[15]);
    var latestWindow = dtSettings.winMediator.getMostRecentWindow('navigator:browser');
    if (latestWindow.getBrowser().moveTabTo == undefined) {
      tablibCheckBox1.collapsed = true;
      tablibCheckBox2.collapsed = true;
    }
    else {
      tablibCheckBox1.collapsed = false;
      tablibCheckBox2.collapsed = false;
      if (latestWindow.duplicateTab.tablibPref && dtSettings.dtPrefs.getBoolPref(latestWindow.duplicateTab.tablibPref)) {
        tablibCheckBox1.disabled = true;
        tablibCheckBox1.checked = true;
      }
      else
        tablibCheckBox1.removeAttribute('disabled');
    }
  },

  setDisabledFirst: function()
  {
    // change disabled attribute of checkbox to allow for message on window close whether window is closed or not
    if (document.getElementById(dtSettings.Consts.IDS.CHECKBOX[6]).getAttribute('checked') != 'true') {
      document.getElementById(dtSettings.Consts.IDS.CHECKBOX[7]).setAttribute('disabled', 'true');
    }
    else if (document.getElementById(dtSettings.Consts.IDS.CHECKBOX[7]).getAttribute('disabled') == 'true') {
      document.getElementById(dtSettings.Consts.IDS.CHECKBOX[7]).removeAttribute('disabled');
    }
  },

  setDisabledSecond: function()
  {
    if (document.getElementById(dtSettings.Consts.IDS.CHECKBOX[14]).getAttribute('checked') != 'true')
      document.getElementById(dtSettings.Consts.IDS.CHECKBOX[15]).setAttribute('disabled', 'true');
    else if (document.getElementById(dtSettings.Consts.IDS.CHECKBOX[15]).getAttribute('disabled') == 'true')
      document.getElementById(dtSettings.Consts.IDS.CHECKBOX[15]).removeAttribute('disabled');
  },

  disableMenuItems: function(event)
  {
    var k, l, i;
    var evtTarget = event.originalTarget;
    var targetChecked = evtTarget.checked;

    switch (evtTarget.id)
    {
      case dtSettings.Consts.IDS.CHECKBOX[10]:
        k = 0;
        break;

      case dtSettings.Consts.IDS.CHECKBOX[11]:
        k = 3;
        break;
    }

    l = k+3;

    for (i = k; i<l; i++) {
      if (targetChecked) {
        document.getElementById(dtSettings.Consts.IDS.SHOWITEMS[i]).setAttribute('disabled', 'true');
        document.getElementById(dtSettings.Consts.IDS.SHOWITEMS[i]).setAttribute('checked', 'true');
      }
      else
        document.getElementById(dtSettings.Consts.IDS.SHOWITEMS[i]).removeAttribute('disabled');
    }
  },

  collapseContent: function(event)
  {
    switch (event.originalTarget.id)
    {
      case dtSettings.Consts.IDS.CHECKBOX[8]:
        document.getElementById(dtSettings.Consts.IDS.COLLAPSEBOXES[0]).collapsed = !event.originalTarget.checked;
        break;
      case dtSettings.Consts.IDS.CHECKBOX[9]:
        document.getElementById(dtSettings.Consts.IDS.COLLAPSEBOXES[1]).collapsed = !event.originalTarget.checked;
        break;
    }
    sizeToContent();
  },

  // Set values of checkboxes and textboxes to default preferences for extension
  setDefaults: function()
  {
    // lock all prefs so defaults are selected
    var i, prefs = dtSettings.Consts.PREFS;
    for (prop in prefs) {
      for (i=0; i<prefs[prop].length; i++) {
        dtSettings.dtPrefs.lockPref(prefs[prop][i]);
      }
    }

    // change all values to defaults by loading with default prefs
    dtSettings.onLoad();

    // unlock all prefs so prefs can be changed again
    for (prop in prefs) {
      for (i=0; i<prefs[prop].length; i++) {
        dtSettings.dtPrefs.unlockPref(prefs[prop][i]);
      }
    }
  },

  /* change preferences to user selected values */
  onAccept: function()
  {
    var i, j, showItemsText = "";
    for (i=0;i<dtSettings.Consts.PREFS.BOOL.length;i++) {
      dtSettings.dtPrefs.setBoolPref(dtSettings.Consts.PREFS.BOOL[i], document.getElementById(dtSettings.Consts.IDS.CHECKBOX[i]).checked);
    }
    for (i=0;i<dtSettings.Consts.IDS.TEXT.length;i++) {
      var numValue = parseInt(document.getElementById(dtSettings.Consts.IDS.TEXT[i]).value);
      var textValue = isNaN(numValue)?0:numValue;
      dtSettings.dtPrefs.setIntPref(dtSettings.Consts.PREFS.TEXT[i], textValue);
    }
    for (i=0; i<3; i++) {
      j=i+3;
      var num1 = (document.getElementById(dtSettings.Consts.IDS.SHOWITEMS[i]).checked)?1:0;
      var num2 = (document.getElementById(dtSettings.Consts.IDS.SHOWITEMS[j]).checked)?2:0;
      showItemsText += (num1+num2).toString();
    }
    dtSettings.dtPrefs.setCharPref(dtSettings.Consts.PREFS.SHOWITEMS[0], showItemsText);
    dtSettings.dtPrefs.setBoolPref(dtSettings.Consts.PREFS.RADIO[0], (!Boolean(document.getElementById(dtSettings.Consts.IDS.RADIO[0]).selectedIndex)));
  },

  onCancel: function() {
  }

}
